
/*
 *  Configuration file for Activate (v1.01)
 *
 *  Utility for setting the Active partition on a HD.
 *
 *  Author: Ronan Mullally October 1992.
 *          < H235_003@ccvax.ucd.ie >
 *          < ronan@bermuda.ucd.ie >
 *          < ronan.mullally@f151.n263.z2.fidonet.org >
 *
 *  Notes: I make *no* guarentees that this program is 100% safe - All
 *         I'll say is that it hasn't damaged my own Hard Disk (yet!)
 *
 *         Most of the code should be fairly portable - the only exceptions
 *         are the functions contained in the DOS-ACT.c and NDOS-ACT.c files.
 *         which contain the routines for reading and writing the 1st sector
 *         of the hard drive.
 *
 */

/* if your DOS compiler doesn't (TCPP does) already declare this, do it here */
/* #define __MSDOS__ */

#ifdef __MSDOS__
 #include <bios.h>                             /* for biosdisk() routine */
 #include "act-dos.c"
#else
 #define NUM_DRIVES 1           /* Pre-define your number of hard drives */
 #include "act-ndos.c"
#endif

/* 
 * Give the names of you hard drives here (ie /dev/whatever) - give the
 * name of the physical drive - NOT the partition numbers! 
 *
 */

#ifndef __MSDOS__                         /* set up array of drive names */
 char *drive_name[NUM_DRIVES] = {"/dev/rat0x"};
#endif


